//
//  NanoVM, a tiny java VM for the Atmel AVR family
//  Copyright (C) 2005 by Till Harbaum <Till@Harbaum.org>
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 

#ifndef TYPES_H
#define TYPES_H

#ifndef NULL
#define NULL ((void*)0)
#endif

#define PACKED __attribute__ ((packed))

/*
 */

typedef unsigned long int  u32_t;
typedef signed long int    s32_t;
typedef unsigned short int u16_t;
typedef signed short int   s16_t;
typedef unsigned char      u08_t;
typedef signed char        s08_t;
typedef unsigned char      bool_t;

/* the minimum integer, that can hold a pointer type */
#ifdef AVR
typedef u16_t         ptr_t;
#else
typedef u32_t         ptr_t;
#endif

#define FALSE 0
#define TRUE  (!FALSE)

#endif // TYPES_H
